<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.8) on Mon Nov 30 13:15:36 CET 2020 -->
<title>RuntimeUtil</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-11-30">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
</head>
<body>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.eclipse.app4mc.amalthea.model.util</a></div>
<h2 title="Class RuntimeUtil" class="title">Class RuntimeUtil</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>Object</li>
<li>
<ul class="inheritance">
<li>RuntimeUtil</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">RuntimeUtil</span>
extends Object</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="RuntimeUtil.AccessDirection.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.AccessDirection</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="RuntimeUtil.PositionType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.PositionType</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static Runnable</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addRuntimeToProcessAsNewRunnable(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ExecutionNeed,java.lang.String,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.PositionType)">addRuntimeToProcessAsNewRunnable</a></span>&#8203;(Process&nbsp;process,
                                ExecutionNeed&nbsp;need,
                                String&nbsp;runnableName,
                                <a href="RuntimeUtil.PositionType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.PositionType</a>&nbsp;positon)</code></th>
<td class="colLast">
<div class="block">Creates a new Runnable with the given runtime at beginning / end of the given process</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static Runnable</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addRuntimeToProcessAsNewRunnable(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Ticks,java.lang.String,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.PositionType)">addRuntimeToProcessAsNewRunnable</a></span>&#8203;(Process&nbsp;process,
                                Ticks&nbsp;ticks,
                                String&nbsp;runnableName,
                                <a href="RuntimeUtil.PositionType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.PositionType</a>&nbsp;positon)</code></th>
<td class="colLast">
<div class="block">Creates a new Runnable with the given runtime at beginning / end of the given process</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addRuntimeToRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ExecutionNeed)">addRuntimeToRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                    ExecutionNeed&nbsp;need)</code></th>
<td class="colLast">
<div class="block">Adds Runtime (given as ExecutionNeed) to an existing Runnable
 currently without consideration of modes</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addRuntimeToRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.Ticks)">addRuntimeToRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                    Ticks&nbsp;ticks)</code></th>
<td class="colLast">
<div class="block">Adds Runtime (given as Ticks) to an existing Runnable
 currently without consideration of modes</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#clearRuntimeOfModel(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.emf.common.util.EMap)">clearRuntimeOfModel</a></span>&#8203;(Amalthea&nbsp;model,
                   EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Clears all runtime information (execution needs and ticks)</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#clearRuntimeOfProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap)">clearRuntimeOfProcess</a></span>&#8203;(Process&nbsp;process,
                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Clears all runtime information (execution needs and ticks)</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#clearRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.emf.common.util.EMap)">clearRuntimeOfRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                      EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Clears all runtime information (execution needs and ticks)</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;Double&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getCumulativeProcessUtilizations(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">getCumulativeProcessUtilizations</a></span>&#8203;(Amalthea&nbsp;model,
                                <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                List&lt;HwFeature&gt;&nbsp;hwFeatures,
                                EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Returns the cumulative process utilization, i.e. runtime on every procUnit summed up</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForCycles(double,org.eclipse.app4mc.amalthea.model.Frequency)">getExecutionTimeForCycles</a></span>&#8203;(double&nbsp;ticks,
                         Frequency&nbsp;frequency)</code></th>
<td class="colLast">
<div class="block">Computes time for a number of ticks with a given frequency</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForExecutionNeedEntry(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.HwFeatureCategory,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForExecutionNeedEntry</a></span>&#8203;(IDiscreteValueDeviation&nbsp;deviation,
                                     HwFeatureCategory&nbsp;hwFeatureCategory,
                                     ProcessingUnit&nbsp;processingUnit,
                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes time for specific execution need entry on a given processing unit</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForExecutionNeeds(org.eclipse.app4mc.amalthea.model.ExecutionNeed,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForExecutionNeeds</a></span>&#8203;(ExecutionNeed&nbsp;need,
                                 ProcessingUnit&nbsp;processingUnit,
                                 <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes time for execution needs on a given processing unit</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForProcess</a></span>&#8203;(Process&nbsp;process,
                          ProcessingUnit&nbsp;processingUnit,
                          EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                          <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes the execution time of a Process (Task or ISR) on a given processing unit</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForProcess</a></span>&#8203;(Process&nbsp;process,
                          EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                          <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes the execution time of a Process (Task or ISR) - unique mapping is required</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                           ProcessingUnit&nbsp;processingUnit,
                           EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                           <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes the execution time of a Runnable on a given processing unit</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForTicks(org.eclipse.app4mc.amalthea.model.Ticks,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForTicks</a></span>&#8203;(Ticks&nbsp;ticks,
                        ProcessingUnit&nbsp;processingUnit,
                        <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes time for ticks on a given processing unit</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>static Time</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExecutionTimeForTicksDeviation(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getExecutionTimeForTicksDeviation</a></span>&#8203;(IDiscreteValueDeviation&nbsp;deviation,
                                 ProcessingUnit&nbsp;processingUnit,
                                 <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</code></th>
<td class="colLast">
<div class="block">Computes time for ticks on a given processing unit</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;List&lt;Time&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPeriodsOfAllProcesses(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">getPeriodsOfAllProcesses</a></span>&#8203;(Amalthea&nbsp;model,
                        <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                        EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Gets all Period ranges from the model</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>static List&lt;Time&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPeriodsOfProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">getPeriodsOfProcess</a></span>&#8203;(Process&nbsp;process,
                   <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                   EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Returns a list of all triggering periods.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>static Map&lt;Stimulus,&#8203;Long&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPlainTriggerForProcess(org.eclipse.app4mc.amalthea.model.Process,long,java.util.function.Function)">getPlainTriggerForProcess</a></span>&#8203;(Process&nbsp;process,
                         long&nbsp;depthCounter,
                         Function&lt;Stimulus,&#8203;Boolean&gt;&nbsp;filter)</code></th>
<td class="colLast">
<div class="block">Returns all stimuli (matching filter) that trigger the given process</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;Map&lt;Stimulus,&#8203;Long&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPlainTriggersForModel(org.eclipse.app4mc.amalthea.model.Amalthea,java.util.function.Function)">getPlainTriggersForModel</a></span>&#8203;(Amalthea&nbsp;model,
                        Function&lt;Stimulus,&#8203;Boolean&gt;&nbsp;filter)</code></th>
<td class="colLast">
<div class="block">Returns a map from process to all stimuli (matching filter) that
 lead to that process with the correct prescaler</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;List&lt;ITimeDeviation&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcessesWithRelativePeriodicStimulus(org.eclipse.app4mc.amalthea.model.Amalthea)">getProcessesWithRelativePeriodicStimulus</a></span>&#8203;(Amalthea&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Returns a Map of all sporadically triggered processes with their prescaler</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;List&lt;Time&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcessesWithRelativePeriodicStimulus(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">getProcessesWithRelativePeriodicStimulus</a></span>&#8203;(Amalthea&nbsp;model,
                                        <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt)</code></th>
<td class="colLast">
<div class="block">Returns a Map of all sporadically triggered processes with their prescaler</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>static Map&lt;ProcessingUnit,&#8203;Double&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">getProcessUtilization</a></span>&#8203;(Process&nbsp;process,
                     Amalthea&nbsp;model,
                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                     List&lt;HwFeature&gt;&nbsp;hwFeatures,
                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Calculates the utilization for a given process</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>static double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">getProcessUtilization</a></span>&#8203;(Process&nbsp;process,
                     ProcessingUnit&nbsp;procUnit,
                     Amalthea&nbsp;model,
                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                     List&lt;HwFeature&gt;&nbsp;hwFeatures,
                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Calculates the utilization for a given process on a given procUnit</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>static double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Time,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">getProcessUtilization</a></span>&#8203;(Process&nbsp;process,
                     Time&nbsp;period,
                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Calculates the process utilization</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>static double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getProcUnitUtilization(org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">getProcUnitUtilization</a></span>&#8203;(ProcessingUnit&nbsp;procUnit,
                      Amalthea&nbsp;model,
                      <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                      List&lt;HwFeature&gt;&nbsp;hwFeatures,
                      EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Calculates the utilization for a given procUnit</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>static double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTicksForExecutionTime(org.eclipse.app4mc.amalthea.model.Time,org.eclipse.app4mc.amalthea.model.Frequency)">getTicksForExecutionTime</a></span>&#8203;(Time&nbsp;executionTime,
                        Frequency&nbsp;frequency)</code></th>
<td class="colLast">
<div class="block">Computes ticks for a given time and frequency.</div>
</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>static double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTicksForExecutionTimeInSeconds(java.math.BigDecimal,org.eclipse.app4mc.amalthea.model.Frequency)">getTicksForExecutionTimeInSeconds</a></span>&#8203;(BigDecimal&nbsp;executionTime,
                                 Frequency&nbsp;frequency)</code></th>
<td class="colLast">
<div class="block">Computes ticks for a given time (in seconds) and frequency.</div>
</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>static Map&lt;Stimulus,&#8203;Long&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTriggeredStimuli(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap)">getTriggeredStimuli</a></span>&#8203;(Process&nbsp;process,
                   EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Returns a map of all stimuli, triggered by this process, associated with its prescaler.</div>
</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>static Map&lt;Process,&#8203;Long&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTriggeringProcesses(org.eclipse.app4mc.amalthea.model.InterProcessStimulus,org.eclipse.emf.common.util.EMap)">getTriggeringProcesses</a></span>&#8203;(InterProcessStimulus&nbsp;ip,
                      EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Returns all Processes that trigger the given InterProcessStimulus</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ExecutionNeed,org.eclipse.emf.common.util.EMap)">setRuntimeOfRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                    ExecutionNeed&nbsp;need,
                    EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Sets the runtime of the given runnable to the given ExecutionNeed</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.Ticks,org.eclipse.emf.common.util.EMap)">setRuntimeOfRunnable</a></span>&#8203;(Runnable&nbsp;runnable,
                    Ticks&nbsp;ticks,
                    EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</code></th>
<td class="colLast">
<div class="block">Sets the runtime of the given runnable to the given Ticks</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getExecutionTimeForProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForProcess</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForProcess&#8203;(Process&nbsp;process,
                                              EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                                              <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes the execution time of a Process (Task or ISR) - unique mapping is required</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>process</code> - task or isr</dd>
<dd><code>modes</code> - (optional) - null works</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForProcess</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForProcess&#8203;(Process&nbsp;process,
                                              ProcessingUnit&nbsp;processingUnit,
                                              EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                                              <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes the execution time of a Process (Task or ISR) on a given processing unit</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>process</code> - task or isr</dd>
<dd><code>processingUnit</code> - executing processing unit</dd>
<dd><code>modes</code> - (optional) - null works</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.emf.common.util.EMap,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForRunnable</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForRunnable&#8203;(Runnable&nbsp;runnable,
                                               ProcessingUnit&nbsp;processingUnit,
                                               EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes,
                                               <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes the execution time of a Runnable on a given processing unit</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>runnable</code> - runnable</dd>
<dd><code>processingUnit</code> - executing processing unit</dd>
<dd><code>modes</code> - (optional) - null works</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForTicks(org.eclipse.app4mc.amalthea.model.Ticks,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForTicks</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForTicks&#8203;(Ticks&nbsp;ticks,
                                            ProcessingUnit&nbsp;processingUnit,
                                            <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes time for ticks on a given processing unit</div>
</li>
</ul>
<a id="getExecutionTimeForTicksDeviation(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForTicksDeviation</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForTicksDeviation&#8203;(IDiscreteValueDeviation&nbsp;deviation,
                                                     ProcessingUnit&nbsp;processingUnit,
                                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes time for ticks on a given processing unit</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>deviation</code> - ticks deviation</dd>
<dd><code>processingUnit</code> - executing processing unit</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForExecutionNeeds(org.eclipse.app4mc.amalthea.model.ExecutionNeed,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForExecutionNeeds</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForExecutionNeeds&#8203;(ExecutionNeed&nbsp;need,
                                                     ProcessingUnit&nbsp;processingUnit,
                                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes time for execution needs on a given processing unit</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>need</code> - execution need</dd>
<dd><code>processingUnit</code> - executing processing unit</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForExecutionNeedEntry(org.eclipse.app4mc.amalthea.model.IDiscreteValueDeviation,org.eclipse.app4mc.amalthea.model.HwFeatureCategory,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForExecutionNeedEntry</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForExecutionNeedEntry&#8203;(IDiscreteValueDeviation&nbsp;deviation,
                                                         HwFeatureCategory&nbsp;hwFeatureCategory,
                                                         ProcessingUnit&nbsp;processingUnit,
                                                         <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;executionCase)</pre>
<div class="block">Computes time for specific execution need entry on a given processing unit</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>deviation</code> - needs deviation</dd>
<dd><code>hwFeatureCategory</code> - corresponding feature category</dd>
<dd><code>processingUnit</code> - executing processing unit</dd>
<dd><code>executionCase</code> - BCET, ACET, WCET</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getExecutionTimeForCycles(double,org.eclipse.app4mc.amalthea.model.Frequency)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionTimeForCycles</h4>
<pre class="methodSignature">public static&nbsp;Time&nbsp;getExecutionTimeForCycles&#8203;(double&nbsp;ticks,
                                             Frequency&nbsp;frequency)</pre>
<div class="block">Computes time for a number of ticks with a given frequency</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ticks</code> - ticks / cycles</dd>
<dd><code>frequency</code> - frequency (of an executing processing unit)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>execution time</dd>
</dl>
</li>
</ul>
<a id="getTicksForExecutionTimeInSeconds(java.math.BigDecimal,org.eclipse.app4mc.amalthea.model.Frequency)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTicksForExecutionTimeInSeconds</h4>
<pre class="methodSignature">public static&nbsp;double&nbsp;getTicksForExecutionTimeInSeconds&#8203;(BigDecimal&nbsp;executionTime,
                                                       Frequency&nbsp;frequency)</pre>
<div class="block">Computes ticks for a given time (in seconds) and frequency.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>executionTime</code> - execution time in seconds</dd>
<dd><code>frequency</code> - frequency (of an executing processing unit)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>ticks / cycles</dd>
</dl>
</li>
</ul>
<a id="getTicksForExecutionTime(org.eclipse.app4mc.amalthea.model.Time,org.eclipse.app4mc.amalthea.model.Frequency)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTicksForExecutionTime</h4>
<pre class="methodSignature">public static&nbsp;double&nbsp;getTicksForExecutionTime&#8203;(Time&nbsp;executionTime,
                                              Frequency&nbsp;frequency)</pre>
<div class="block">Computes ticks for a given time and frequency.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>executionTime</code> - execution time</dd>
<dd><code>frequency</code> - frequency (of an executing processing unit)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>ticks / cycles</dd>
</dl>
</li>
</ul>
<a id="setRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ExecutionNeed,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setRuntimeOfRunnable</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;setRuntimeOfRunnable&#8203;(Runnable&nbsp;runnable,
                                        ExecutionNeed&nbsp;need,
                                        EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Sets the runtime of the given runnable to the given ExecutionNeed</div>
</li>
</ul>
<a id="setRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.Ticks,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setRuntimeOfRunnable</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;setRuntimeOfRunnable&#8203;(Runnable&nbsp;runnable,
                                        Ticks&nbsp;ticks,
                                        EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Sets the runtime of the given runnable to the given Ticks</div>
</li>
</ul>
<a id="addRuntimeToRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.ExecutionNeed)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addRuntimeToRunnable</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;addRuntimeToRunnable&#8203;(Runnable&nbsp;runnable,
                                        ExecutionNeed&nbsp;need)</pre>
<div class="block">Adds Runtime (given as ExecutionNeed) to an existing Runnable
 currently without consideration of modes</div>
</li>
</ul>
<a id="addRuntimeToRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.app4mc.amalthea.model.Ticks)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addRuntimeToRunnable</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;addRuntimeToRunnable&#8203;(Runnable&nbsp;runnable,
                                        Ticks&nbsp;ticks)</pre>
<div class="block">Adds Runtime (given as Ticks) to an existing Runnable
 currently without consideration of modes</div>
</li>
</ul>
<a id="clearRuntimeOfModel(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearRuntimeOfModel</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;clearRuntimeOfModel&#8203;(Amalthea&nbsp;model,
                                       EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Clears all runtime information (execution needs and ticks)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>model</code> - Amalthea model</dd>
<dd><code>modes</code> - (optional) - null works</dd>
</dl>
</li>
</ul>
<a id="clearRuntimeOfProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearRuntimeOfProcess</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;clearRuntimeOfProcess&#8203;(Process&nbsp;process,
                                         EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Clears all runtime information (execution needs and ticks)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>process</code> - task or isr</dd>
<dd><code>modes</code> - (optional) - null works</dd>
</dl>
</li>
</ul>
<a id="clearRuntimeOfRunnable(org.eclipse.app4mc.amalthea.model.Runnable,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearRuntimeOfRunnable</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;clearRuntimeOfRunnable&#8203;(Runnable&nbsp;runnable,
                                          EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Clears all runtime information (execution needs and ticks)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>runnable</code> - runnable</dd>
<dd><code>modes</code> - (optional) - null works</dd>
</dl>
</li>
</ul>
<a id="addRuntimeToProcessAsNewRunnable(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ExecutionNeed,java.lang.String,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.PositionType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addRuntimeToProcessAsNewRunnable</h4>
<pre class="methodSignature">public static&nbsp;Runnable&nbsp;addRuntimeToProcessAsNewRunnable&#8203;(Process&nbsp;process,
                                                        ExecutionNeed&nbsp;need,
                                                        String&nbsp;runnableName,
                                                        <a href="RuntimeUtil.PositionType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.PositionType</a>&nbsp;positon)</pre>
<div class="block">Creates a new Runnable with the given runtime at beginning / end of the given process</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>process</code> - containing process (task or isr)</dd>
<dd><code>need</code> - execution need</dd>
<dd><code>runnableName</code> - name of new runnable</dd>
<dd><code>positon</code> - FIRST, LAST</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the new runnable</dd>
</dl>
</li>
</ul>
<a id="addRuntimeToProcessAsNewRunnable(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Ticks,java.lang.String,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.PositionType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addRuntimeToProcessAsNewRunnable</h4>
<pre class="methodSignature">public static&nbsp;Runnable&nbsp;addRuntimeToProcessAsNewRunnable&#8203;(Process&nbsp;process,
                                                        Ticks&nbsp;ticks,
                                                        String&nbsp;runnableName,
                                                        <a href="RuntimeUtil.PositionType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.PositionType</a>&nbsp;positon)</pre>
<div class="block">Creates a new Runnable with the given runtime at beginning / end of the given process</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>process</code> - containing process (task or isr)</dd>
<dd><code>ticks</code> - ticks</dd>
<dd><code>runnableName</code> - name of new runnable</dd>
<dd><code>positon</code> - FIRST, LAST</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the new runnable</dd>
</dl>
</li>
</ul>
<a id="getProcUnitUtilization(org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcUnitUtilization</h4>
<pre class="methodSignature">public static&nbsp;double&nbsp;getProcUnitUtilization&#8203;(ProcessingUnit&nbsp;procUnit,
                                            Amalthea&nbsp;model,
                                            <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                            List&lt;HwFeature&gt;&nbsp;hwFeatures,
                                            EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Calculates the utilization for a given procUnit</div>
</li>
</ul>
<a id="getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcessUtilization</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;ProcessingUnit,&#8203;Double&gt;&nbsp;getProcessUtilization&#8203;(Process&nbsp;process,
                                                                     Amalthea&nbsp;model,
                                                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                                                     List&lt;HwFeature&gt;&nbsp;hwFeatures,
                                                                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Calculates the utilization for a given process</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Map: procUnit -&gt; utilization</dd>
</dl>
</li>
</ul>
<a id="getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.ProcessingUnit,org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcessUtilization</h4>
<pre class="methodSignature">public static&nbsp;double&nbsp;getProcessUtilization&#8203;(Process&nbsp;process,
                                           ProcessingUnit&nbsp;procUnit,
                                           Amalthea&nbsp;model,
                                           <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                           List&lt;HwFeature&gt;&nbsp;hwFeatures,
                                           EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Calculates the utilization for a given process on a given procUnit
 <p>
 Assumption (wrong): All triggers activate the process on all procUnits together! (at the same time)</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>utilization</dd>
</dl>
</li>
</ul>
<a id="getProcessUtilization(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.Time,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcessUtilization</h4>
<pre class="methodSignature">public static&nbsp;double&nbsp;getProcessUtilization&#8203;(Process&nbsp;process,
                                           Time&nbsp;period,
                                           <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                           EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Calculates the process utilization</div>
</li>
</ul>
<a id="getCumulativeProcessUtilizations(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,java.util.List,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCumulativeProcessUtilizations</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;Double&gt;&nbsp;getCumulativeProcessUtilizations&#8203;(Amalthea&nbsp;model,
                                                                         <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                                                         List&lt;HwFeature&gt;&nbsp;hwFeatures,
                                                                         EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Returns the cumulative process utilization, i.e. runtime on every procUnit summed up</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Map: process -&gt; sum of utilization on all procUnits</dd>
</dl>
</li>
</ul>
<a id="getPeriodsOfAllProcesses(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPeriodsOfAllProcesses</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;List&lt;Time&gt;&gt;&nbsp;getPeriodsOfAllProcesses&#8203;(Amalthea&nbsp;model,
                                                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                                                     EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Gets all Period ranges from the model</div>
</li>
</ul>
<a id="getPeriodsOfProcess(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPeriodsOfProcess</h4>
<pre class="methodSignature">public static&nbsp;List&lt;Time&gt;&nbsp;getPeriodsOfProcess&#8203;(Process&nbsp;process,
                                             <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt,
                                             EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Returns a list of all triggering periods. Sorted by shortest period first!</div>
</li>
</ul>
<a id="getTriggeringProcesses(org.eclipse.app4mc.amalthea.model.InterProcessStimulus,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTriggeringProcesses</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;Long&gt;&nbsp;getTriggeringProcesses&#8203;(InterProcessStimulus&nbsp;ip,
                                                             EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Returns all Processes that trigger the given InterProcessStimulus</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Map: process -&gt; prescaler value</dd>
</dl>
</li>
</ul>
<a id="getTriggeredStimuli(org.eclipse.app4mc.amalthea.model.Process,org.eclipse.emf.common.util.EMap)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTriggeredStimuli</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Stimulus,&#8203;Long&gt;&nbsp;getTriggeredStimuli&#8203;(Process&nbsp;process,
                                                           EMap&lt;ModeLabel,&#8203;String&gt;&nbsp;modes)</pre>
<div class="block">Returns a map of all stimuli, triggered by this process, associated with its prescaler.</div>
</li>
</ul>
<a id="getProcessesWithRelativePeriodicStimulus(org.eclipse.app4mc.amalthea.model.Amalthea,org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcessesWithRelativePeriodicStimulus</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;List&lt;Time&gt;&gt;&nbsp;getProcessesWithRelativePeriodicStimulus&#8203;(Amalthea&nbsp;model,
                                                                                     <a href="RuntimeUtil.TimeType.html" title="enum in org.eclipse.app4mc.amalthea.model.util">RuntimeUtil.TimeType</a>&nbsp;tt)</pre>
<div class="block">Returns a Map of all sporadically triggered processes with their prescaler</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Map of processes with a sporadic activation and depending on tt the
         time between activations</dd>
</dl>
</li>
</ul>
<a id="getProcessesWithRelativePeriodicStimulus(org.eclipse.app4mc.amalthea.model.Amalthea)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getProcessesWithRelativePeriodicStimulus</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;List&lt;ITimeDeviation&gt;&gt;&nbsp;getProcessesWithRelativePeriodicStimulus&#8203;(Amalthea&nbsp;model)</pre>
<div class="block">Returns a Map of all sporadically triggered processes with their prescaler</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Map of processes with a sporadic activation and the deviation of the
         activations</dd>
</dl>
</li>
</ul>
<a id="getPlainTriggersForModel(org.eclipse.app4mc.amalthea.model.Amalthea,java.util.function.Function)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlainTriggersForModel</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Process,&#8203;Map&lt;Stimulus,&#8203;Long&gt;&gt;&nbsp;getPlainTriggersForModel&#8203;(Amalthea&nbsp;model,
                                                                                   Function&lt;Stimulus,&#8203;Boolean&gt;&nbsp;filter)</pre>
<div class="block">Returns a map from process to all stimuli (matching filter) that
 lead to that process with the correct prescaler</div>
</li>
</ul>
<a id="getPlainTriggerForProcess(org.eclipse.app4mc.amalthea.model.Process,long,java.util.function.Function)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getPlainTriggerForProcess</h4>
<pre class="methodSignature">public static&nbsp;Map&lt;Stimulus,&#8203;Long&gt;&nbsp;getPlainTriggerForProcess&#8203;(Process&nbsp;process,
                                                                 long&nbsp;depthCounter,
                                                                 Function&lt;Stimulus,&#8203;Boolean&gt;&nbsp;filter)</pre>
<div class="block">Returns all stimuli (matching filter) that trigger the given process</div>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
</body>
</html>
